searchData={"content_type":"text/markdown","items":[{"doc":"Provides functions to convert svg to png using resvg.","ref":"Resvg.html","title":"Resvg","type":"module"},{"doc":"The supported options are:\n\n  * `:width` - Set the width in pixels.\n  * `:height` - Set the height in pixels.\n  * `:zoom` - Zoom image by a factor, Example: `2.0`.\n  * `:dpi` - Sets the resolution, default to `96`.\n  * `:background` - Sets the background color, accept CSS3 color\n  Example: `red`, `#fff`, `#fff000`.\n  * `:languages` - Sets a list of languages that will be used during the\n  `systemLanguage` attribute resolving, Example: `[\"en-US\", \"fr-FR\"]`, default\n  to `[\"en\"]`.\n  * `:shape_rendering` - Selects the default shape rendering method\n  default to `:geometric_precision`.\n  * `:text_rendering` - Selects the default text rendering method\n  default to `:optimize_legibility`.\n  * `:image_rendering` - Selects the default image rendering method\n  default to `:optimize_quality`.\n  * `:resources_dir` - Sets a directory that will be used during relative\n  paths resolving. This field is mandatory for all functions\n  except `svg_to_png/3` because it default to the `svg_input` path.\n  * `:font_family` - Sets the default font family that will be used when\n  no `font-family` is present, default to `Times New Roman`.\n  * `:font_size` - Sets the default font size that will be used when no\n  `font-size` is present, default to `12`.\n  * `:serif_family` - Sets the `serif` font family, default to\n  `Time New Roman`.\n  * `:sans_serif_family` - Sets the `sans-serif` font family, default to\n  `Arial`.\n  * `:cursive_family` - Sets the `cursive` font family, default to\n  `Comic Sans MS`.\n  * `:fantasy_family` - Sets the `fantasy` font family, default to\n  `Impact`.\n  * `:monospace_family` - Sets the `monoscape` font family, default to\n  `Courier New`.\n  * `:font_files` - Load specified font files into the fonts database.\n  * `:font_dirs` - Load all fonts from the specified directory into the fonts\n  database.\n  * `:skip_system_fonts` - Disable systems fonts loading. You should add some\n  some fonts with `:font_files` or `:font_dirs` otherwise, text elements will\n  not be processed.","ref":"Resvg.html#module-common-options","title":"Common options - Resvg","type":"module"},{"doc":"List successfully loaded font faces. Useful for debugging.\n\n`opts` refer to [options](#module-common-options) must at least set the\n`resources_dir` key to a valid path.\n\nThe functions return `{:ok, fonts_list}` in case of success. Otherise, it returns \n`{:error, reason}` if an error occurs.","ref":"Resvg.html#list_fonts/1","title":"Resvg.list_fonts/1","type":"function"},{"doc":"Resvg.list_fonts(resources_dir: \"/tmp\")\n    {:ok, [\"/usr/share/fonts/truetype/dejavu/DejaVuSansMono-BoldOblique.ttf..\", ...]}","ref":"Resvg.html#list_fonts/1-examples","title":"Examples - Resvg.list_fonts/1","type":"function"},{"doc":"Queries all valid SVG ids with bounding boxes\n\n`opts` refer to [options](#module-common-options)\n\nThe functions return `{:ok, fonts_list}` in case of success. Otherise, it returns \n`{:error, reason}` if an error occurs.","ref":"Resvg.html#query_all/2","title":"Resvg.query_all/2","type":"function"},{"doc":"Resvg.query_all(\"rustacean.svg\")\n    [\n      %Resvg.Native.Node{\n        id: \"Layer-1\",\n        x: -63.99300003051758,\n        y: 90.14399719238281,\n        width: 1304.344970703125,\n        height: 613.6170043945312\n      }\n    ]","ref":"Resvg.html#query_all/2-examples","title":"Examples - Resvg.query_all/2","type":"function"},{"doc":"Try to convert `svg_string` to `out_png`.\n\n`svg_string` must be a valid svg file.\n`out_png` must be a path to a non-existent file.\n`opts` refer to [options](#module-common-options) must at least set the\n`resources_dir` key to a valid path.\n\nThe functions return `:ok` in case of success. Otherise, it returns \n`{:error, reason}` if an error occurs.","ref":"Resvg.html#svg_string_to_png/3","title":"Resvg.svg_string_to_png/3","type":"function"},{"doc":"svg_string = \"\n       \n         \n       \"\n    Resvg.svg_string_to_png(svg_string, \"output.png\", resources_dir: \"/tmp\")\n    :ok","ref":"Resvg.html#svg_string_to_png/3-examples","title":"Examples - Resvg.svg_string_to_png/3","type":"function"},{"doc":"Try to convert `svg_string` to a png buffer..\n\n`svg_string` must be a valid svg file.\n`opts` refer to [options](#module-common-options) must at least set the\n`resources_dir` key to a valid path.\n\nThe functions return `{:ok, buffer}` in case of success. Otherise, it returns \n`{:error, reason}` if an error occurs.","ref":"Resvg.html#svg_string_to_png_buffer/2","title":"Resvg.svg_string_to_png_buffer/2","type":"function"},{"doc":"svg_string = \"\n       \n         \n       \"\n    Resvg.svg_string_to_png(svg_string, \"output.png\", resources_dir: \"/tmp\")\n    {:ok, buffer}","ref":"Resvg.html#svg_string_to_png_buffer/2-examples","title":"Examples - Resvg.svg_string_to_png_buffer/2","type":"function"},{"doc":"Try to convert the contents of `in_svg` to `out_png`.\n\n`in_svg` must be a path to a valid svg file.\n`out_png` must be a path to a non-existent file.\n`opts` refer to [options](#module-common-options)\n\nThe functions return `:ok` in case of success. Otherise, it returns \n`{:error, reason}` if an error occurs.","ref":"Resvg.html#svg_to_png/3","title":"Resvg.svg_to_png/3","type":"function"},{"doc":"Resvg.svg_to_png(\"input.svg\", \"output.png\")\n    :ok\n\n    Resvg.svg_to_png(\"doesnotexist.svg\", \"output.png\")\n    {:error, \"Error loading svg file: No such file or directory (os error 2)\"}","ref":"Resvg.html#svg_to_png/3-examples","title":"Examples - Resvg.svg_to_png/3","type":"function"},{"doc":"Options for Resvg.","ref":"Resvg.Options.html","title":"Resvg.Options","type":"module"},{"doc":"","ref":"Resvg.Options.html#t:image_rendering/0","title":"Resvg.Options.image_rendering/0","type":"type"},{"doc":"","ref":"Resvg.Options.html#t:resvg_options/0","title":"Resvg.Options.resvg_options/0","type":"type"},{"doc":"The options for resvg functions.","ref":"Resvg.Options.html#t:shape_rendering/0","title":"Resvg.Options.shape_rendering/0","type":"type"},{"doc":"","ref":"Resvg.Options.html#t:text_rendering/0","title":"Resvg.Options.text_rendering/0","type":"type"},{"doc":"# Changelog\n\nAll notable changes to this project will be documented in this file.\n\nThe format is based on [Keep a Changelog](http://keepachangelog.com/en/1.0.0/)\nand this project adheres to [Semantic Versioning](http://semver.org/spec/v2.0.0.html).\n\n## [Unreleased]\n\n---\n\n## [0.3.3] – 2024-07-04\n- Update dependencies.\n\n## [0.3.2] – 2024-06-21\n- Update dependencies.\n\n## [0.3.1] – 2024-04-20\n- Fix `query_all/2` by loading the fonts to get the correct size.\n\n## [0.3.0] – 2023-07-07\n- Add new function `query_all/2`.\n\n## [0.2.0] – 2023-06-22\n- Change render types to atom\n\n## [0.1.0] – 2023-06-21\nInitial release","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"# Contributing to resvg_nif\n\nThanks for considering to contribute to resvg_nif. ❤\n\nBug reports, feature suggestions, and pull requests for any open issues are very welcome. Issues can be reported on GitHub: https://github.com/mrdotb/resvg_nif/issues/new.\n\nPlease read and follow our [Code of Conduct](https://github.com/mrdotb/resvg_nif/blob/main/CODE_OF_CONDUCT.md).","ref":"contributing.html","title":"Contributing","type":"extras"},{"doc":"In order to setup the development environment you need to have some dependencies installed on your machine:\n\n- [git](https://git-scm.com/downloads)\n- [Rust](https://www.rust-lang.org/learn/get-started)\n- [Elixir](https://elixir-lang.org/install.html)\n\nCheckout the resvg_nif repository with\n\n```\n$ git clone git@github.com:mrdotb/resvg_nif.git\n```\n\nThen step into the project directory and install the dependencies with \n\n```\nmix deps.get\n```\n\n\nTo force local compilation you need to set the env\n```\nexport RESVG_BUILD=1 \n```","ref":"contributing.html#development-setup","title":"Development setup - Contributing","type":"extras"},{"doc":"Here’s how to contribute:\n\n* Fork it (https://github.com/mrdotb/resvg_nif/fork)\n* Create your feature branch (git checkout -b feature/my-new-feature)\n* Commit your changes (git commit -am 'Add some feature')\n* Push to the branch (git push origin feature/my-new-feature)\n* Create a new Pull Request\n\nTry to add tests along with your new feature. This will ensure that your code does not break existing functionality and that your feature is working as expected. You can run the tests with:\n\n```bash\nmix test\n```\n\nIf you’ve changed any Elixir code or Rust code, please run Elixir’s and Rust's  code formatter before committing your changes:\n\n```bash\nmix format.all\n```\n\nThis will keep the code style consistent and future code diffs as small as possible.","ref":"contributing.html#how-to-contribute","title":"How to Contribute - Contributing","type":"extras"},{"doc":"For detailed info about what needs to be done in order to publish a new version of\nthe resvg package on hex.pm, please refer to the release flow section in the\n[precompilation guide](https://hexdocs.pm/rustler_precompiled/precompilation_guide.html)\nof `rustler_precompiled`.\n\n---------\n\nAs a contributor, please keep in mind this project is free and open source software. Maintainers are not paid to work on it, so there might be times were the maintainers seem unresponsive. If you have that feeling, please be patient and be assured, that all team members try their best to review your contribution and reply to you as soon as their time allows.","ref":"contributing.html#publishing-a-new-package-version","title":"Publishing a new package version - Contributing","type":"extras"},{"doc":"# Contributor Covenant Code of Conduct","ref":"code_of_conduct.html","title":"Code of Conduct","type":"extras"},{"doc":"We as members, contributors, and leaders pledge to make participation in our\ncommunity a harassment-free experience for everyone, regardless of age, body\nsize, visible or invisible disability, ethnicity, sex characteristics, gender\nidentity and expression, level of experience, education, socio-economic status,\nnationality, personal appearance, race, religion, or sexual identity\nand orientation.\n\nWe pledge to act and interact in ways that contribute to an open, welcoming,\ndiverse, inclusive, and healthy community.","ref":"code_of_conduct.html#our-pledge","title":"Our Pledge - Code of Conduct","type":"extras"},{"doc":"Examples of behavior that contributes to a positive environment for our\ncommunity include:\n\n* Demonstrating empathy and kindness toward other people\n* Being respectful of differing opinions, viewpoints, and experiences\n* Giving and gracefully accepting constructive feedback\n* Accepting responsibility and apologizing to those affected by our mistakes,\n  and learning from the experience\n* Focusing on what is best not just for us as individuals, but for the\n  overall community\n\nExamples of unacceptable behavior include:\n\n* The use of sexualized language or imagery, and sexual attention or\n  advances of any kind\n* Trolling, insulting or derogatory comments, and personal or political attacks\n* Public or private harassment\n* Publishing others' private information, such as a physical or email\n  address, without their explicit permission\n* Other conduct which could reasonably be considered inappropriate in a\n  professional setting","ref":"code_of_conduct.html#our-standards","title":"Our Standards - Code of Conduct","type":"extras"},{"doc":"Community leaders are responsible for clarifying and enforcing our standards of\nacceptable behavior and will take appropriate and fair corrective action in\nresponse to any behavior that they deem inappropriate, threatening, offensive,\nor harmful.\n\nCommunity leaders have the right and responsibility to remove, edit, or reject\ncomments, commits, code, wiki edits, issues, and other contributions that are\nnot aligned to this Code of Conduct, and will communicate reasons for moderation\ndecisions when appropriate.","ref":"code_of_conduct.html#enforcement-responsibilities","title":"Enforcement Responsibilities - Code of Conduct","type":"extras"},{"doc":"This Code of Conduct applies within all community spaces, and also applies when\nan individual is officially representing the community in public spaces.\nExamples of representing our community include using an official e-mail address,\nposting via an official social media account, or acting as an appointed\nrepresentative at an online or offline event.","ref":"code_of_conduct.html#scope","title":"Scope - Code of Conduct","type":"extras"},{"doc":"Instances of abusive, harassing, or otherwise unacceptable behavior may be\nreported to the community leaders responsible for enforcement by \nopening an issue or contacting one or more of the project maintainers.\nAll complaints will be reviewed and investigated promptly and fairly.\n\nAll community leaders are obligated to respect the privacy and security of the\nreporter of any incident.","ref":"code_of_conduct.html#enforcement","title":"Enforcement - Code of Conduct","type":"extras"},{"doc":"Community leaders will follow these Community Impact Guidelines in determining\nthe consequences for any action they deem in violation of this Code of Conduct:","ref":"code_of_conduct.html#enforcement-guidelines","title":"Enforcement Guidelines - Code of Conduct","type":"extras"},{"doc":"**Community Impact**: Use of inappropriate language or other behavior deemed\nunprofessional or unwelcome in the community.\n\n**Consequence**: A private, written warning from community leaders, providing\nclarity around the nature of the violation and an explanation of why the\nbehavior was inappropriate. A public apology may be requested.","ref":"code_of_conduct.html#1-correction","title":"1. Correction - Code of Conduct","type":"extras"},{"doc":"**Community Impact**: A violation through a single incident or series\nof actions.\n\n**Consequence**: A warning with consequences for continued behavior. No\ninteraction with the people involved, including unsolicited interaction with\nthose enforcing the Code of Conduct, for a specified period of time. This\nincludes avoiding interactions in community spaces as well as external channels\nlike social media. Violating these terms may lead to a temporary or\npermanent ban.","ref":"code_of_conduct.html#2-warning","title":"2. Warning - Code of Conduct","type":"extras"},{"doc":"**Community Impact**: A serious violation of community standards, including\nsustained inappropriate behavior.\n\n**Consequence**: A temporary ban from any sort of interaction or public\ncommunication with the community for a specified period of time. No public or\nprivate interaction with the people involved, including unsolicited interaction\nwith those enforcing the Code of Conduct, is allowed during this period.\nViolating these terms may lead to a permanent ban.","ref":"code_of_conduct.html#3-temporary-ban","title":"3. Temporary Ban - Code of Conduct","type":"extras"},{"doc":"**Community Impact**: Demonstrating a pattern of violation of community\nstandards, including sustained inappropriate behavior,  harassment of an\nindividual, or aggression toward or disparagement of classes of individuals.\n\n**Consequence**: A permanent ban from any sort of public interaction within\nthe community.","ref":"code_of_conduct.html#4-permanent-ban","title":"4. Permanent Ban - Code of Conduct","type":"extras"},{"doc":"This Code of Conduct is adapted from the [Contributor Covenant][homepage],\nversion 2.0, available at\nhttps://www.contributor-covenant.org/version/2/0/code_of_conduct.html.\n\nCommunity Impact Guidelines were inspired by [Mozilla's code of conduct\nenforcement ladder](https://github.com/mozilla/diversity).\n\n[homepage]: https://www.contributor-covenant.org\n\nFor answers to common questions about this code of conduct, see the FAQ at\nhttps://www.contributor-covenant.org/faq. Translations are available at\nhttps://www.contributor-covenant.org/translations.","ref":"code_of_conduct.html#attribution","title":"Attribution - Code of Conduct","type":"extras"},{"doc":"# MIT License\n\nCopyright (c) 2023 Mrdotb\n\nPermission is hereby granted, free of charge, to any person obtaining a copy of this software and associated documentation files (the \"Software\"), to deal in the Software without restriction, including without limitation the rights to use, copy, modify, merge, publish, distribute, sublicense, and/or sell copies of the Software, and to permit persons to whom the Software is furnished to do so, subject to the following conditions:\n\nThe above copyright notice and this permission notice shall be included in all copies or substantial portions of the Software.\n\nTHE SOFTWARE IS PROVIDED \"AS IS\", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS IN THE SOFTWARE.","ref":"license.html","title":"License","type":"extras"},{"doc":"# Resvg (Rust NIFs for elixir)\n\n[![Build Status](https://github.com/mrdotb/resvg_nif/workflows/Tests/badge.svg)](https://github.com/mrdotb/resvg_nif/workflows/Tests/badge.svg)\n[![Module Version](https://img.shields.io/hexpm/v/resvg.svg)](https://hex.pm/packages/resvg)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-lightgreen.svg)](https://hexdocs.pm/resvg)\n[![Total Download](https://img.shields.io/hexpm/dt/resvg.svg)](https://hex.pm/packages/resvg)\n[![License](https://img.shields.io/hexpm/l/resvg.svg)](https://github.com/mrdotb/resvg_nif/blob/master/LICENSE.md)\n\nNative Implemented Function (NIF) bindings for the [resvg](https://github.com/RazrFalcon/resvg) library.\n\nAbout resvg from its documentation:\n> resvg is an SVG rendering library. The core idea is to make a fast, small, portable SVG library with the goal to support the whole SVG spec.","ref":"readme.html","title":"Overview","type":"extras"},{"doc":"The package can be installed\nby adding `resvg_nif` to your list of dependencies in `mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:resvg, \"~> 0.3.0\"}\n  ]\nend\n```","ref":"readme.html#installation","title":"Installation - Overview","type":"extras"},{"doc":"Convert svg to png with:\n\n```elixir\n:ok = Resvg.svg_to_png(\"input.svg\", \"output.png\")\n\nsvg_string = \"\"\"\n \n   \n \n\"\"\"\n:ok = Resvg.svg_string_to_png(svg_string, \"output.png\", resources_dir: \"/tmp\")\n```","ref":"readme.html#usage","title":"Usage - Overview","type":"extras"},{"doc":"Easiest way to get started and try more advanced example is is to run the Livebook.\n\n[![Run in Livebook](https://livebook.dev/badge/v1/blue.svg)](https://livebook.dev/run?url=https%3A%2F%2Fgithub.com%2Fmrdotb%2Fresvg_nif%2Fblob%2Fmaster%2Flivebooks%2Fexample.livemd)","ref":"readme.html#livebook-introduction","title":"Livebook introduction - Overview","type":"extras"},{"doc":"You can contribute to resvg_nif. Please check the [CONTRIBUTING.md](CONTRIBUTING.md) guide for more information.\n\nThis project is intended to be a safe, welcoming space for collaboration, and contributors are expected to adhere to our [CODE_OF_CONDUCT.md](/CODE_OF_CONDUCT.md).","ref":"readme.html#contributing","title":"Contributing - Overview","type":"extras"},{"doc":"Copyright (c) 2023 Mrdotb\n\nThis work is free. You can redistribute it and / or modify it under the terms of the MIT License. See the LICENSE.md file for more details.","ref":"readme.html#copyright-and-license","title":"Copyright and License - Overview","type":"extras"}],"producer":{"name":"ex_doc","version":[48,46,51,52,46,49]}}